import mx.utils.Delegate;

class us.mojocosmetics.allies.QuotesView extends MovieClip
{
	private var quotes:Array;
	private var TXT_Quotes:TextField;
	
	private var index:Number;
	private var waitTime:Number = 200;
	private var delay:Number = 0;
	
	function QuotesView()
	{
		quotes = this._parent._parent.assets.quotes.obj.quotes[0].quote.reverse();
		index = -1;
		_alpha = 0;
		nextQuote();
	}
	private function nextQuote():Void
	{
		if (++index == quotes.length) index = 0;
		TXT_Quotes.text = quotes[index];
		this.onEnterFrame = Delegate.create(this, fadeIn);
	}
	private function fadeIn():Void
	{
		var alpha:Number = this._alpha + 3;
		if (alpha < 33)
		{
			_alpha = alpha;
		}
		else
		{
			_alpha = 33;
			delay = 0;
			this.onEnterFrame = Delegate.create(this, wait);
		}
	}
	private function fadeOut():Void
	{
		var alpha:Number = this._alpha - 3;
		if (alpha > 0)
		{
			_alpha = alpha;
		}
		else
		{
			_alpha = 0;
			nextQuote();
		}
	}
	private function wait()
	{
		if (++delay >= waitTime) this.onEnterFrame = Delegate.create(this, fadeOut);
	}
}