import flash.external.ExternalInterface;
import mx.utils.Delegate;

class us.mojocosmetics.nav.GlobalNav extends MovieClip
{
	private var BTN_Propaganda:MovieClip;
	private var BTN_Xchange:MovieClip;
	private var BTN_Allies:MovieClip;
	private var BTN_Press:MovieClip;
	private var BTN_Headquarters:MovieClip;
	
	private var BTN_Radio:MovieClip;
	private var MC_Notes:MovieClip;
	
	private var BTN_Send:MovieClip;
	private var INP_Email:TextField;
	
	private var LV_Send:LoadVars;
	private var LV_Receive:LoadVars;

	private var buttons:Array;
	
	function GlobalNav()
	{
		_global.Gaia.afterGoto(Delegate.create(this, onAfterGoto));
		_global.Gaia.afterComplete(Delegate.create(this, onAfterGoto), false, true);
	}
	public function configUI():Void
	{
		BTN_Send.onRelease = Delegate.create(this, clickSend);
		INP_Email.restrict = "A-Za-z_@.0-9\\-";
		INP_Email.onSetFocus = Delegate.create(this, emailSetFocus);
		INP_Email.onKillFocus = Delegate.create(this, emailKillFocus);
		INP_Email.onChanged = Delegate.create(this, validateEmail);
		validateEmail();
		buttons = [BTN_Propaganda, BTN_Xchange, BTN_Allies, BTN_Press, BTN_Headquarters];
		var i:Number = buttons.length;
		while (i--)
		{
			buttons[i].branch = "index/" + String(buttons[i]._name.split("_").pop()).toLowerCase();
			buttons[i].onRelease = function()
			{
				if (this.branch != "index/xchange")
				{
					_global.Gaia.goto(this.branch);
				}
				else
				{
					_global.Gaia.goto(this.branch + "/titan");
				}
			};
		}
		onAfterGoto({validBranch:_global.Gaia.getCurrentBranch()});
	}
	private function onAfterGoto(evt:Object):Void
	{
		var i:Number = buttons.length;
		while (i--)
		{
			if (evt.validBranch == buttons[i].branch)
			{
				buttons[i].gotoAndStop("selected");
				buttons[i].enabled = false;
			}
			else
			{
				buttons[i].enabled = true;
				buttons[i].gotoAndStop("_up");
			}
		}
	}
	//
	// EMAIL FORM
	private function clickSend():Void
	{
		// send email
		delete INP_Email.onSetFocus;
		delete INP_Email.onKillFocus;
		delete INP_Email.onChanged;
		//
		//BTN_Send.enabled = false;
		//
		LV_Send = new LoadVars();
		LV_Send.mailing_list_email = INP_Email.text;
		LV_Send.mailing_list_action = "authorized";
		//
		LV_Receive = new LoadVars();
		LV_Receive.onLoad = Delegate.create(this, onSubmitResponse);
		var mailphp:String = (_root._url.indexOf("//www.") > -1) ? "http://www.mojocosmetics.us/join_mailing_list.php" : "http://mojocosmetics.us/join_mailing_list.php";
		LV_Send.sendAndLoad(mailphp, LV_Receive, "POST");
	}
	private function onSubmitResponse(success:Boolean):Void
	{
		if (success)
		{
			if (LV_Receive.mailing_list_result == "done")
			{
				INP_Email.type = "dynamic";
				INP_Email.selectable = false;
				INP_Email.text = "Welcome Aboard!";
				INP_Email._x = 170;
				BTN_Send._visible = false;
			}
			else
			{
				BTN_Send.enabled = true;
				ExternalInterface.call("alert", "Your email did not go through. Please contact an administator or try again.");
			}
		}
		else
		{
			BTN_Send.enabled = true;
			ExternalInterface.call("alert", "Unable to connect to server");
		}
	}
	private function emailSetFocus():Void
	{
		if (INP_Email.text == "your@email.com") INP_Email.text = "";
	}
	private function emailKillFocus():Void
	{
		if (INP_Email.text.length == 0) INP_Email.text = "your@email.com";
	}
	private function validateEmail():Void
	{
		if ((INP_Email.text != "your@email.com") && checkEmail(INP_Email.text) == 1)
		{
			BTN_Send._alpha = 100;
			BTN_Send.enabled = true;
		}
		else
		{
			BTN_Send._alpha = 30;
			BTN_Send.enabled = false;
		}
	}
	function checkEmail(e):Number
	{
		var i, j, l = e.length;
		var foundPoint = false;

		function checkChars (s, i, l) {
			while (i < l && ("_-abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789").indexOf(s.charAt(i)) != -1){
				i++;
			}
			return i;
		}
		function checkFirstLevelDomainChars (s, i, l) {
			while (i < l && ("abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ").indexOf(s.charAt(i)) != -1) {
				i++;
			}
			return (i == l);
		}
		//trace(e);

		// every email starts with a string
		if ((i=checkChars(e, 0, l)) == 0) {
			return -1;
		}
		//init j
		j=i;

		// followed by an arbitrary number of ("." string) combinations
		while (i < l && e.charAt(i) == ".") {
			// skip the point
			i++;
			// if there are no chars, we have an error
			if ((j=checkChars(e, i, l)) == i) {
				return -2;
			}
			// else skip the chars
			i = j;
		}
		// then follows the magic @
		if (e.charAt(i) != "@"){
			return -3;
		}

		// followed by minimum one string point string
		// after the last point minimum 2 characters are allowed

		do {
			// skip the @ (j == i at the beginning, so it is like i++)
			i = j+1;
			// do we have more chars ?
			j = checkChars(e, i, l);
			if (j == i) {
				// no more chars found -> error
				return -4;
			} else if (j == e.length) {
				// emailaddress is finished, do we have a first level domain ?
				j -= i;
				// we have one if it is at least 2 long and consists of the correct characters
				if(foundPoint && j>=2 && checkFirstLevelDomainChars(e, i, l)){
					return 1
				} else {
					return -5
				}
			}
			// if we reach the end or don't have a point, we return an error
			foundPoint = (e.charAt(j) == ".");
		} while (i < l && foundPoint);
		return -6;
	}
}