import net.stevensacks.utils.ObservableClip;
import us.mojocosmetics.allies.Scrollbar;
import mx.utils.Delegate;

class us.mojocosmetics.press.Press extends ObservableClip
{
	private var MC_Newsie:MovieClip;
	private var MC_Shadow:MovieClip;
	
	private var MC_Copy:MovieClip;
	private var MC_Magazine:MovieClip;
	
	private var BTN_Next:MovieClip;
	private var BTN_ClickFlash:MovieClip;
	
	private var MC_Scrollbar:us.mojocosmetics.allies.Scrollbar;
	
	private var stories:Array;
	private var covers:Array;
	
	private var storyIndex:Number;
	private var coverIndex:Number;
	private var offset:Number = 280;
	
	function Press()
	{
		super();
		storyIndex = 0;
		coverIndex = 0;
	}
	private function configUI():Void
	{
		stories = randomize(this._parent.assets.stories.obj.stories[0].story);
		covers = randomize(this._parent.assets.magazines.obj.magazines[0].cover);
		_global.gNewsieDance = Delegate.create(this, newsieDance);
		BTN_ClickFlash.onPress = Delegate.create(this, clickFlash);
		BTN_ClickFlash.useHandCursor = false;
		BTN_Next.onRelease = Delegate.create(this, nextStory);
		MC_Scrollbar.addEventListener("change", Delegate.create(this, onScroll));
		nextStory();
		nextCover();
	}
	private function transitionIn():Void
	{
		gotoAndPlay("in");
	}
	private function transitionOut():Void
	{
		gotoAndStop("out");
	}
	private function nextStory():Void
	{
		MC_Scrollbar.reset();
		MC_Copy.setCopy(stories[storyIndex++]);
		if (storyIndex == stories.length) storyIndex = 0;
	}
	private function updateCopyHeight():Void
	{
		BTN_Next._y = offset + Math.min(MC_Copy._height, 230);
		checkScroll();
	}
	private function nextCover():Void
	{
		var node:Object = covers[coverIndex++];
		MC_Magazine.setCover(node.toString(), node.attributes.title);
		if (coverIndex == covers.length) coverIndex = 0;
	}
	private function checkScroll():Void
	{
		MC_Scrollbar._visible = (MC_Copy._height > 225);
	}
	private function onScroll(evt:Object):Void
	{
		MC_Copy._y = offset - ((MC_Copy._height - 225) * evt.data);
	}
	private function clickFlash():Void
	{
		_global.gPhotoFlash();
	}
	private function newsieDance(bool:Boolean):Void
	{
		if (bool)
		{
			MC_Newsie.gotoAndStop(2);
			MC_Shadow.gotoAndStop(2);
		}
		else
		{
			MC_Newsie.gotoAndStop(1);
			MC_Shadow.gotoAndStop(1);
		}
	}
	private function randomize(p:Array):Array
	{
		var i:Number = p.length;
		if (i == 0) return [];
		while (--i)
		{
			var j:Number = Math.floor(Math.random() * (i + 1));
			var tmp1 = p[i];
			var tmp2 = p[j];
			p[i] = tmp2;
			p[j] = tmp1;
		}
		return p;
	}
}