import mx.utils.Delegate;

class us.mojocosmetics.propaganda.MoviePlayer extends MovieClip
{
	private var data:Array;
	private var index:Number;
	private var isIntro:Boolean;
	
	function MoviePlayer()
	{
		super();
		_global.gNextPropaganda = Delegate.create(this, showNext);
		data = randomize(_parent.assets.movies.obj.videos[0].video);
		isIntro = true;
		index = 0;
		start();
	}
	private function start():Void
	{
		var mc:MovieClip = this.createEmptyMovieClip("MC_Intro", this.getNextHighestDepth());
		mc.loadMovie("video/propaganda/greyintro.swf");
		this.onEnterFrame = Delegate.create(this, checkIntroLoaded);
		mc = this.createEmptyMovieClip("MC_Movie0", this.getNextHighestDepth());
		mc.loadMovie(data[0]);
	}
	private function showNext():Void
	{
		if (!isIntro)
		{
			if (++index == data.length) index = 0;
			var mc:MovieClip = this.createEmptyMovieClip("MC_Movie" + index, this.getNextHighestDepth());
			mc.loadMovie(data[index]);
			this.onEnterFrame = Delegate.create(this, checkNextLoaded);
		}
		else
		{
			isIntro = false;
			this.onEnterFrame = Delegate.create(this, checkFirstLoaded);
		}
	}
	private function checkIntroLoaded():Void
	{
		var ref:MovieClip = this["MC_Intro"];
		if (ref.getBytesLoaded() == ref.getBytesTotal() && ref.getBytesTotal() > 4)
		{
			ref.gotoAndPlay(2);
			delete this.onEnterFrame;
		}
	}
	private function checkFirstLoaded():Void
	{
		var ref:MovieClip = this["MC_Movie0"];
		if (ref.getBytesLoaded() == ref.getBytesTotal() && ref.getBytesTotal() > 4)
		{
			this["MC_Intro"].gotoAndStop(1);
			this["MC_Intro"]._visible = true;
			this["MC_Intro"].removeMovieClip();
			ref.gotoAndStop(2);
			delete this.onEnterFrame;
		}
	}
	private function checkNextLoaded():Void
	{
		var ref:MovieClip = this["MC_Movie" + index];
		if (ref.getBytesLoaded() == ref.getBytesTotal() && ref.getBytesTotal() > 4)
		{
			if (index > 0) this["MC_Movie" + (index - 1)].removeMovieClip();
			else this["MC_Movie" + (data.length - 1)].removeMovieClip();
			ref.gotoAndStop(2);
			delete this.onEnterFrame;
		}
	}
	private function randomize(p:Array):Array
	{
		var i:Number = p.length;
		if (i == 0) return [];
		while (--i)
		{
			var j:Number = Math.floor(Math.random() * (i + 1));
			var tmp1 = p[i];
			var tmp2 = p[j];
			p[i] = tmp2;
			p[j] = tmp1;
		}
		return p;
	}
}