import net.stevensacks.utils.ObservableClip;

class us.mojocosmetics.xchange.SelectList extends ObservableClip
{
	private var SYMBOL:String;
	private var ROW_HEIGHT:Number;	
	private var MC_Items:MovieClip;
	private var data:Array;
	
	private var selectedIndex:Number;
	
	function SelectList()
	{
		draw();
	}
	public function get value():String
	{
		return String(data[selectedIndex].data || data[selectedIndex]);
	}
	private function draw():Void
	{
		MC_Items.removeMovieClip();
		var mc:MovieClip = this.createEmptyMovieClip("MC_Items", 10);
		mc._y = 27;
		for (var i:Number = 0; i < data.length; i++)
		{
			var row:MovieClip = mc.attachMovie(SYMBOL, "item" + i, i);
			row._y = ROW_HEIGHT * i;
			row.controller = this;
			row._alpha = 30;
			row.id = i;
			row.label = data[i].label || data[i];
			row.onRelease = function()
			{
				this.controller.click(this.id);
			};
		}
		click(0);
	}
	private function click(id:Number):Void
	{
		selectedIndex = id;
		var i:Number = data.length;
		while (i--)
		{
			if (i != id) 
			{
				MC_Items["item" + i].enabled = true;
				MC_Items["item" + i].gotoAndStop("_up");
			}
			else
			{
				MC_Items["item" + i].gotoAndStop("selected");
				MC_Items["item" + i].enabled = false;
			}
		}
		dispatchEvent({type:"select", data:data[id].data || data[id]});
	}
}