import net.stevensacks.utils.ObservableClip;
import us.mojocosmetics.xchange.ProductIds;
import us.mojocosmetics.xchange.SelectList;
import flash.external.ExternalInterface;
import mx.utils.Delegate;

class us.mojocosmetics.xchange.OrderForm extends ObservableClip
{	
	private var MC_Titan:SelectList;
	private var MC_TitanSilverPearls:SelectList;
	private var MC_BulletLipstick1:SelectList;
	private var MC_BulletLipstick2:SelectList;
	private var MC_BulletConcealer1:SelectList;
	private var MC_Pod:SelectList;
	private var MC_Lacquer:SelectList;
	private var MC_Quantity:SelectList;
	
	private var MC_Price:MovieClip;
	private var BTN_AddToCart:MovieClip;
	
	private var price:Number;
	private var quantity:Number;
	private var product1:String;	
	private var product2:String;	
	
	private var colorDelegate1:Function;
	private var colorDelegate2:Function;
	private var quantityDelegate:Function;
	
	function OrderForm()
	{
		super();
		ProductIds.init();
		colorDelegate1 = Delegate.create(this, onColorSelect1);
		colorDelegate2 = Delegate.create(this, onColorSelect2);
		quantityDelegate = Delegate.create(this, onQuantitySelect);
	}
	
	private function titan():Void
	{
		price = 20;
		initProduct();
		product1 = "titanium grey";
		MC_Titan.addEventListener("select", colorDelegate1);
		MC_Quantity.addEventListener("select", quantityDelegate);
		BTN_AddToCart.onRelease = Delegate.create(this, titanAddToCart);
	}
	private function titanSilverPearls():Void
	{
		price = 15;
		initProduct();
		product1 = "sphere";
		MC_TitanSilverPearls.addEventListener("select", colorDelegate1);
		MC_Quantity.addEventListener("select", quantityDelegate);
		BTN_AddToCart.onRelease = Delegate.create(this, titanSilverPearlsAddToCart);
	}
	private function bulletLipstick():Void
	{
		price = 15;
		initProduct();
		product1 = "caliber";
		MC_BulletLipstick1.addEventListener("select", colorDelegate1);
		BTN_AddToCart.onRelease = Delegate.create(this, bulletLipstickAddToCart);
	}
	private function bulletConcealer():Void
	{
		price = 20;
		initProduct();
		product1 = "1";
		MC_BulletConcealer1.addEventListener("select", colorDelegate1);
		BTN_AddToCart.onRelease = Delegate.create(this, bulletConcealerAddToCart);
	}
	private function platinum():Void
	{
		price = 12;
		initProduct();
		MC_Quantity.addEventListener("select", quantityDelegate);
		BTN_AddToCart.onRelease = Delegate.create(this, platinumAddToCart);
	}
	private function pod():Void
	{
		price = 20;
		initProduct();
		product1 = "vintage";
		MC_Pod.addEventListener("select", colorDelegate1);
		MC_Quantity.addEventListener("select", quantityDelegate);
		BTN_AddToCart.onRelease = Delegate.create(this, podAddToCart);
	}
	private function lacquer():Void
	{
		price = 13;
		initProduct();
		product1 = "conviction";
		MC_Lacquer.addEventListener("select", colorDelegate1);
		MC_Quantity.addEventListener("select", quantityDelegate);
		BTN_AddToCart.onRelease = Delegate.create(this, lacquerAddToCart);
	}
	private function fullmonty():Void
	{
		price = 42;
		initProduct();
		product1 = "titanium grey";
		product2 = "caliber";
		MC_Titan.addEventListener("select", colorDelegate1);
		MC_BulletLipstick1.addEventListener("select", colorDelegate2);
		BTN_AddToCart.onRelease = Delegate.create(this, fullmontyAddToCart);
	}
	private function doublebarrel():Void
	{
		price = 27;
		initProduct();
		product1 = "caliber";
		product2 = "caliber";
		MC_BulletLipstick1.addEventListener("select", colorDelegate1);
		MC_BulletLipstick2.addEventListener("select", colorDelegate2);
		BTN_AddToCart.onRelease = Delegate.create(this, doublebarrelAddToCart);
	}
	private function mojounisex():Void
	{
		price = 30;
		initProduct();
		MC_Quantity.addEventListener("select", quantityDelegate);
		BTN_AddToCart.onRelease = Delegate.create(this, mojounisexAddToCart);
	}
	private function initProduct():Void
	{
		quantity = 1;
		product1 = null;
		product2 = null;
		updatePrice();
	}
	private function updatePrice():Void
	{
		MC_Price.label = "$" + (quantity * price) + ".00";
	}
	private function titanAddToCart():Void
	{
		var lv:LoadVars = new LoadVars();
		lv["id[1]"] = ProductIds.titan[product1];
		lv.products_id = 1;
		addToCart(lv);
	}
	private function titanSilverPearlsAddToCart():Void
	{
		var lv:LoadVars = new LoadVars();
		lv["id[1]"] = ProductIds.titanSilverPearls[product1];
		lv.products_id = 1;
		addToCart(lv);
	}
	private function bulletLipstickAddToCart():Void
	{
		var lv:LoadVars = new LoadVars();
		lv["id[2]"] = ProductIds.bulletLipstick[product1];
		lv.products_id = 2;
		addToCart(lv);
	}
	private function bulletConcealerAddToCart():Void
	{
		var lv:LoadVars = new LoadVars();
		lv["id[2]"] = ProductIds.bulletConcealer[product1];
		lv.products_id = 10;
		addToCart(lv);
	}
	private function platinumAddToCart():Void
	{
		var lv:LoadVars = new LoadVars();
		lv.products_id = 3;
		addToCart(lv);
	}
	private function podAddToCart():Void
	{
		var lv:LoadVars = new LoadVars();
		lv.products_id = 3;
		addToCart(lv);
	}
	private function lacquerAddToCart():Void
	{
		var lv:LoadVars = new LoadVars();
		lv.products_id = 3;
		addToCart(lv);
	}
	private function fullmontyAddToCart():Void
	{
		var lv:LoadVars = new LoadVars();
		lv["id[1]"] = ProductIds.montyTitan[product1];
		lv["id[2]"] = ProductIds.montyBullet[product2];
		lv["id[4]"] = 17;
		lv.products_id = 6;
		addToCart(lv, "&number_of_uploads=0");
	}
	private function doublebarrelAddToCart():Void
	{
		var lv:LoadVars = new LoadVars();
		lv["id[2]"] = ProductIds.double1[product1];
		lv["id[3]"] = ProductIds.double2[product2];
		lv.products_id = 5;
		addToCart(lv, "&number_of_uploads=0");
	}
	private function mojounisexAddToCart():Void
	{
		var lv:LoadVars = new LoadVars();
		lv.products_id = 7;
		addToCart(lv, "&number_of_uploads=0");
	}
	private function addToCart(lv:LoadVars, addUrl:String):Void
	{
		lv.cart_quantity = quantity;
		var url:String = "http://www.mojocosmetics.us/shop/index.php?main_page=product_info&action=add_product" + (addUrl || "");
		ExternalInterface.call("launchCart", "blank.html");
		lv.send(url, "mojocart", "POST");
	}
	// LISTENERS
	private function onColorSelect1(evt:Object):Void
	{
		product1 = evt.data;
		dispatchEvent({type:"colorSelect1", data:product1});
	}
	private function onColorSelect2(evt:Object):Void
	{
		product2 = evt.data;
		dispatchEvent({type:"colorSelect2", data:product2});
	}
	private function onQuantitySelect(evt:Object):Void
	{
		quantity = evt.data;
		updatePrice();
	}
}