import net.stevensacks.utils.ObservableClip;
import mx.utils.Delegate;

class us.mojocosmetics.xchange.ProductSelect extends ObservableClip
{	
	public var catalogPDF:String = "http://www.mojocosmetics.us/mojocatalog_lowrez.pdf";
	
	private var BTN_Titan:MovieClip;
	private var BTN_TitanSilverPearls:MovieClip;
	private var BTN_BulletLipstick:MovieClip;
	private var BTN_BulletConcealer:MovieClip;
	private var BTN_Platinum:MovieClip;
	private var BTN_Pod:MovieClip;
	private var BTN_Lacquer:MovieClip;
	private var BTN_FullMonty:MovieClip;
	private var BTN_DoubleBarrel:MovieClip;
	private var BTN_MojoUnisex:MovieClip;
	private var BTN_Catalog:MovieClip;
	
	private var buttons:Array = [];
	
	function ProductSelect()
	{
		super();
		BTN_Titan.onRelease = Delegate.create(this, clickTitan);
		BTN_TitanSilverPearls.onRelease = Delegate.create(this, clickTitanSilverPearls);
		BTN_BulletLipstick.onRelease = Delegate.create(this, clickBulletLipstick);
		BTN_BulletConcealer.onRelease = Delegate.create(this, clickBulletConcealer);
		BTN_Platinum.onRelease = Delegate.create(this, clickPlatinum);
		BTN_Pod.onRelease = Delegate.create(this, clickPod);
		BTN_Lacquer.onRelease = Delegate.create(this, clickLacquer);
		BTN_FullMonty.onRelease = Delegate.create(this, clickFullMonty);
		BTN_DoubleBarrel.onRelease = Delegate.create(this, clickDoubleBarrel);
		BTN_MojoUnisex.onRelease = Delegate.create(this, clickMojoUnisex);
		BTN_Catalog.onRelease = Delegate.create(this, clickCatalog);
		buttons = [BTN_Titan, BTN_TitanSilverPearls, BTN_BulletLipstick, BTN_BulletConcealer, BTN_Platinum, BTN_Pod, BTN_Lacquer, BTN_FullMonty, BTN_DoubleBarrel, BTN_MojoUnisex];
	}
	public function clickTitan(ignore:Boolean):Void
	{
		selectButton(BTN_Titan);
		dispatchEvent({type:"select", data:"titan"});
		if (!ignore) _global.Gaia.goto(_parent._parent.page.branch + "/titan");
	}
	public function clickTitanSilverPearls(ignore:Boolean):Void
	{
		selectButton(BTN_TitanSilverPearls);
		dispatchEvent({type:"select", data:"titansilverpearls"});
		if (!ignore) _global.Gaia.goto(_parent._parent.page.branch + "/titan-silver-pearls");
	}
	public function clickBulletLipstick(ignore:Boolean):Void
	{
		selectButton(BTN_BulletLipstick);
		dispatchEvent({type:"select", data:"bulletlipstick"});
		if (!ignore) _global.Gaia.goto(_parent._parent.page.branch + "/bullet-lipstick");
	}
	public function clickBulletConcealer(ignore:Boolean):Void
	{
		selectButton(BTN_BulletConcealer);
		dispatchEvent({type:"select", data:"bulletconcealer"});
		if (!ignore) _global.Gaia.goto(_parent._parent.page.branch + "/bullet-concealer");
	}
	public function clickPlatinum(ignore:Boolean):Void
	{
		selectButton(BTN_Platinum);
		dispatchEvent({type:"select", data:"platinum"});
		if (!ignore) _global.Gaia.goto(_parent._parent.page.branch + "/platinum");
	}
	public function clickPod(ignore:Boolean):Void
	{
		selectButton(BTN_Pod);
		dispatchEvent({type:"select", data:"pod"});
		if (!ignore) _global.Gaia.goto(_parent._parent.page.branch + "/pod");
	}
	public function clickLacquer(ignore:Boolean):Void
	{
		selectButton(BTN_Lacquer);
		dispatchEvent({type:"select", data:"lacquer"});
		if (!ignore) _global.Gaia.goto(_parent._parent.page.branch + "/lacquer");
	}
	public function clickFullMonty(ignore:Boolean):Void
	{
		selectButton(BTN_FullMonty);
		dispatchEvent({type:"select", data:"fullmonty"});
		if (!ignore) _global.Gaia.goto(_parent._parent.page.branch + "/full-monty");
	}
	public function clickDoubleBarrel(ignore:Boolean):Void
	{
		selectButton(BTN_DoubleBarrel);
		dispatchEvent({type:"select", data:"doublebarrel"});
		if (!ignore) _global.Gaia.goto(_parent._parent.page.branch + "/double-barrel");
	}
	public function clickMojoUnisex(ignore:Boolean):Void
	{
		selectButton(BTN_MojoUnisex);
		dispatchEvent({type:"select", data:"mojounisex"});
		if (!ignore) _global.Gaia.goto(_parent._parent.page.branch + "/mojo-unisex");
	}
	private function clickCatalog():Void 
	{
		_global.Gaia.href(catalogPDF, "_blank");
	}
	private function selectButton(btn:MovieClip):Void
	{
		var i:Number = buttons.length;
		while (i--)
		{
			if (buttons[i] != btn)
			{
				buttons[i].enabled = true;
				buttons[i].gotoAndStop("_up");
			}
		}
		btn.gotoAndStop("_over");
		btn.enabled = false;
	}
}