import us.mojocosmetics.xchange.ProductSelect;
import us.mojocosmetics.xchange.Products;
import flash.external.ExternalInterface;
import mx.utils.Delegate;

class us.mojocosmetics.xchange.Xchange extends MovieClip
{	
	private var MC_Products:Products;
	private var MC_ProductSelect:ProductSelect;
	
	private var BTN_Privacy:MovieClip;
	private var BTN_Shipping:MovieClip;
	
	private var BTN_Login:MovieClip;
	private var BTN_Cart:MovieClip;
	
	private var speed:Number = 10;
	private var currentProduct:String = "titan";

	function Xchange()
	{
		//
	}
	private function configUI():Void
	{
		MC_ProductSelect.addEventListener("select", Delegate.create(this, onSelectProduct));
		if (_global.Gaia.getDeeplink().length > 0)
		{
			onDeeplink(_global.Gaia.getDeeplink());
		}
		else
		{
			MC_ProductSelect.clickTitan();
		}
		BTN_Cart.onRelease = Delegate.create(this, clickCart);
		BTN_Login.onRelease = Delegate.create(this, clickLogin);
		BTN_Privacy.onRelease = Delegate.create(this, clickPrivacy);
		BTN_Shipping.onRelease = Delegate.create(this, clickShipping);
	}
	public function onDeeplink(deeplink:String):Void
	{
		if (deeplink.length > 0)
		{
			deeplink = deeplink.substr(1);
			if (deeplink == "titan")
			{
				MC_ProductSelect.clickTitan(true);
			}
			if (deeplink == "titan-silver-pearls")
			{
				MC_ProductSelect.clickTitanSilverPearls(true);
			}
			else if (deeplink == "bullet-lipstick")
			{
				MC_ProductSelect.clickBulletLipstick(true);
			}
			else if (deeplink == "bullet-concealer")
			{
				MC_ProductSelect.clickBulletConcealer(true);
			}
			else if (deeplink == "platinum")
			{
				MC_ProductSelect.clickPlatinum(true);
			}
			else if (deeplink == "pod")
			{
				MC_ProductSelect.clickPod(true);
			}
			else if (deeplink == "lacquer")
			{
				MC_ProductSelect.clickLacquer(true);
			}
			else if (deeplink == "full-monty")
			{
				MC_ProductSelect.clickFullMonty(true);
			}
			else if (deeplink == "double-barrel")
			{
				MC_ProductSelect.clickDoubleBarrel(true);
			}
			else if (deeplink == "mojo-unisex")
			{
				MC_ProductSelect.clickMojoUnisex(true);
			}
		}
	}
	private function onSelectProduct(evt:Object):Void
	{
		currentProduct = evt.data;
		onEnterFrame = Delegate.create(this, fadeOut);
	}
	private function clickPrivacy():Void
	{
		_parent.showPopup("privacy");
	}
	private function clickShipping():Void
	{
		_parent.showPopup("shipping");
	}
	private function clickLogin():Void
	{
		ExternalInterface.call("launchCart", "https://mojocosmetics.us/shop/index.php?main_page=login");
	}
	private function clickCart():Void
	{
		ExternalInterface.call("launchCart", "https://mojocosmetics.us/shop/index.php?main_page=shopping_cart");
	}
	private function fadeOut():Void
	{
		var alpha:Number = MC_Products._alpha - speed;
		if (alpha > 0)
		{
			MC_Products._alpha = alpha;
		}
		else
		{
			MC_Products._alpha = 0;
			MC_Products.product = currentProduct;
			onEnterFrame = Delegate.create(this, fadeIn);
		}
	}
	private function fadeIn():Void
	{
		var alpha:Number = MC_Products._alpha + speed;
		if (alpha < 100)
		{
			MC_Products._alpha = alpha;
		}
		else
		{
			MC_Products._alpha = 100;
			delete onEnterFrame;
		}
	}
}